﻿using System;
using System.Collections.Generic;
using System.Windows.Forms;

namespace Hwasung_Windows_SDK
{
    public partial class Form1 : Form
    {
        HW_API hw_api = new HW_API();        

        public Form1()
        {
            InitializeComponent();
        }

        private void Form1_Load(object sender, EventArgs e)
        {
            comboBox1.Items.Add("HMK-060");
            comboBox1.Items.Add("HMK-080");
            comboBox1.Items.Add("HMK-081");
            comboBox1.Items.Add("HMK-825");
            comboBox1.Items.Add("HMK-830");
            comboBox1.Items.Add("HMK-072");
            comboBox1.Items.Add("HMK-054");
            comboBox1.Items.Add("HP-083");
            comboBox1.Items.Add("HP-283");
            comboBox1.SelectedIndex = 0;


            comboBox2.Items.Add("USB");
            comboBox2.Items.Add("COM1");
            comboBox2.Items.Add("COM2");
            comboBox2.Items.Add("COM3");
            comboBox2.Items.Add("COM4");
            comboBox2.Items.Add("COM5");
            comboBox2.Items.Add("COM6");
            comboBox2.Items.Add("COM7");
            comboBox2.SelectedIndex = 0;

            comboBox3.Items.Add("9600");
            comboBox3.Items.Add("19200");
            comboBox3.Items.Add("38400");
            comboBox3.Items.Add("57600");
            comboBox3.Items.Add("115200");
            comboBox3.SelectedIndex = 0;

            comboBox4.Items.Add("UPC_A");
            comboBox4.Items.Add("UPC-E");
            comboBox4.Items.Add("EAN13");
            comboBox4.Items.Add("EAN8");
            comboBox4.Items.Add("CODE39");
            comboBox4.Items.Add("ITF(I of 2/5)");
            comboBox4.Items.Add("CODABAR");
            comboBox4.Items.Add("CODE93");
            comboBox4.Items.Add("CODE128 A");
            comboBox4.Items.Add("CODE128 B");
            comboBox4.Items.Add("CODE128 C");
            comboBox4.SelectedIndex = 0;

            comboBox5.Items.Add("Version 1");
            comboBox5.Items.Add("Version 3");
            comboBox5.Items.Add("Version 5");
            comboBox5.Items.Add("Version 9");
            comboBox5.SelectedIndex = 0;

            ComboBox6.Items.Add("Xon/Xoff");
            ComboBox6.Items.Add("RTS/CTS");
            ComboBox6.Items.Add("DTR/DSR");
            ComboBox6.SelectedIndex = 1;

            label5.Text = "";
            textBox1.Text = "1234567890";
            textBox2.Text = "1234567890";
        }
        private int port_open(object port, int baudrate)
        {
            int port_open = 20;
            int a;
            if (port.Equals("USB"))
            {
                a = HW_API.printerOpen(hw_api.INT_USB, 0, comboBox1.SelectedItem.ToString(), 0, 0);
                port_open = a;
            }
            else
            {
                a = HW_API.printerOpen(hw_api.INT_SERIAL, comboBox2.SelectedIndex, comboBox1.SelectedItem.ToString(), ComboBox6.SelectedIndex, int.Parse(comboBox3.SelectedItem.ToString()));
                port_open = a;
            }
            return port_open;
        }
        private void button1_Click(object sender, EventArgs e)
        {   //printer status
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1) 
            {
                prt_status((byte)HW_API.printerStatus());
            }
        }
        delegate void SetTextCallback(string text);
        private void SetText(string text)
        {
            if (this.InvokeRequired)
            {
                SetTextCallback d = new SetTextCallback(SetText);
                this.Invoke(d, new object[] { text });
            }
            else
            {
                this.label5.Text = text;
            }
        }
        private void prt_status(byte status)
        {
            switch (status)
            {
                case 0:
                    SetText("Normal Status");
                    break;
                case 1:
                    SetText("Paper out");
                    break;
                case 2:
                    SetText("Head open");
                    break;
                case 3:
                    SetText("Paper out && Head open");
                    break;
                case 4:
                    SetText("Paper Jam");
                    break;
                case 5:
                    SetText("Paper out && Paper Jam");
                    break;
                case 6:
                    SetText("Head open && Paper Jam");
                    break;
                case 7:
                    SetText("Paper out && Head open && Paper Jam");
                    break;
                case 8:
                    SetText("Near End");
                    break;
                case 9:
                    SetText("Paper out && Near end");
                    break;
                case 10:
                    SetText("Head open && Near end");
                    break;
                case 11:
                    SetText("Paper out && Head open && Near end");
                    break;
                case 12:
                    SetText("Paper Jam && Near end");
                    break;
                case 13:
                    SetText("Paper out && Paper Jam && Near end");
                    break;
                case 14:
                    SetText("Head open && Paper Jam && Near end");
                    break;
                case 15:
                    SetText("Paper out && Head open && Paper Jam && Near end");
                    break;
                case 16:
                    SetText("Print Running");
                    break;
                case 32:
                    SetText("Cutter Jam");
                    break;
            }
        }
        private void button3_Click(object sender, EventArgs e)
        {
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1)
            {
                if (comboBox4.SelectedIndex >= 8)
                {
                    HW_API.barCode(textBox1.Text, comboBox4.SelectedIndex, hw_api.HRI_NONE, 0, hw_api.vb_Default, hw_api.vb_Default);
                }
                else
                {
                    if (comboBox4.SelectedIndex == 1 || comboBox4.SelectedIndex == 3)
                    {
                        if (textBox1.TextLength < 7)
                        {
                            textBox1.Text = "0123456";
                        }
                        HW_API.barCode(textBox1.Text.Substring(0, 7), comboBox4.SelectedIndex, hw_api.HRI_NONE, 0, hw_api.vb_Default, hw_api.vb_Default);
                    }
                    else if (comboBox4.SelectedIndex == 2)
                    {
                        if (textBox1.TextLength < 12)
                        {
                            textBox1.Text = "012345678901";
                        }
                        HW_API.barCode(textBox1.Text.Substring(0, 12), comboBox4.SelectedIndex, hw_api.HRI_NONE, 0, hw_api.vb_Default, hw_api.vb_Default);
                    }
                    else if (comboBox4.SelectedIndex == 5)
                    {
                        if (textBox1.TextLength % 2 == 0)
                        {
                            HW_API.barCode(textBox1.Text, comboBox4.SelectedIndex, hw_api.HRI_NONE, 0, hw_api.vb_Default, hw_api.vb_Default);
                        }
                        else
                        {
                            HW_API.barCode(textBox1.Text + "0", comboBox4.SelectedIndex, hw_api.HRI_NONE, 0, hw_api.vb_Default, hw_api.vb_Default);
                        }
                    }
                    else
                    {
                        HW_API.barCode(textBox1.Text, comboBox4.SelectedIndex, hw_api.HRI_NONE, 0, hw_api.vb_Default, hw_api.vb_Default);
                    }
                }
            }            
        }
        private void button4_Click(object sender, EventArgs e)
        {
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1)
            {
                // PAGE MODE
                HW_API.setPagemode();
                // PAGE 방향
                HW_API.setPagemodeDirection(hw_api.PAGEDIRECTION_L_90);
                // 좌표지정 및 문자열출력

                HW_API.setTicketposition("0010", "1160");
                HW_API.printStr("Thermal Printer Ticket Sample");

                HW_API.setTicketposition("0104", "1160");
                HW_API.printStr("Hwasung System Thermal Printer");

                HW_API.setTicketposition("0136", "1160");
                HW_API.printStr("Sample Print");

                HW_API.setTicketposition("0216", "1160");
                HW_API.printStr(DateTime.Now.ToString());

                HW_API.setTicketposition("0280", "1160");
                HW_API.printStr("Page Mode Ticket Sample");

                HW_API.textSize(1, 0);
                HW_API.setTicketposition("0104", "0304");
                HW_API.printStr("Page Mode");

                HW_API.textSize(0, 0);
                HW_API.setTicketposition("0168", "0304");
                HW_API.printStr("Sample Print");

                HW_API.setTicketposition("0416", "1160");
                HW_API.printStr("Thermal Printer Ticket Sample");

                //-------- - BARCODE--------------------------------

                HW_API.setTicketposition("0376", "0688");

                HW_API.barCode("010001200307311439", hw_api.BARCODE_CODABAR, 0, 0, hw_api.vb_Default, 40);

                // PAGE AREA PRINT
                HW_API.printPagemode();
                // PAGE AREA CLEAR AND TO STANDARD MODE
                HW_API.setLinemode();

                // -----------------------
            }          
        }

        private void button5_Click(object sender, EventArgs e)
        {
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1)
            {
                byte[] MyData;
                MyData = new byte[8];

                // PAGE MODE
                HW_API.setPagemode();

                // PAGE TOWARD
                HW_API.setPagemodeDirection(hw_api.PAGEDIRECTION_0);

                HW_API.setPagemodePosition(0, 0, 160, 217);

                //location x = 0mm
                //location y = 0mm
                //dx = 20mm
                //dy = 27.125mm
                HW_API.printStr("ABCDEFGHIJKLM");

                HW_API.setPagemodePosition(112, 144, 160, 217);

                //location x = 14mm
                //location y = 18mm
                //dx = 20mm
                //dy = 27.125mm
                HW_API.printStr("1234567890123");

                HW_API.setPagemodePosition(160, 96, 160, 217);
                //location x = 20mm
                //location y = 12mm
                //dx = 20mm
                //dy = 27.125mm
                HW_API.printStr("123ABC456DEF7");

                // PAGE AREA PRINT
                HW_API.printPagemode();

                // PAGE AREA CLEAR AND TO STANDARD MODE
                HW_API.setLinemode();

            }          
        }

        private void button6_Click(object sender, EventArgs e)
        {
            string str = comboBox5.SelectedItem.ToString();
            string val = str.Remove(0, str.Length - 1);
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1)
            {
                switch (val)
                {
                    case "1":
                        HW_API.qrCode(textBox2.Text, hw_api.QR_VER_1);
                        break;
                    case "3":
                        HW_API.qrCode(textBox2.Text, hw_api.QR_VER_3);
                        break;
                    case "5":
                        HW_API.qrCode(textBox2.Text, hw_api.QR_VER_5);
                        break;
                    case "9":
                        HW_API.qrCode(textBox2.Text, hw_api.QR_VER_9);
                        break;
                }

            }           
        }

        private void button7_Click(object sender, EventArgs e)
        {
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1)
            {
                HW_API.cut(hw_api.CUT_FULL);
            }           
        }

        private void button8_Click(object sender, EventArgs e)
        {
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1)
            {
                HW_API.cut(hw_api.CUT_PARTIAL);
            }           
        }

        private void button9_Click(object sender, EventArgs e)
        {
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1)
            {
                HW_API.cut(hw_api.CUT_BM);
            }           
        }

        private void button2_Click(object sender, EventArgs e)
        {
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1)
            {
                byte[] MyData = new byte[1];
                //Extended ascii mode 
                HW_API.ext_asc(true);

                //Text Align center
                HW_API.textAlign(hw_api.ALIGN_CENTER);


                HW_API.printStr("Starbucks Coffee Germany");
                HW_API.feedLine(2);
                HW_API.printStr("Frankfrut am Main");
                HW_API.feedLine(1);
                HW_API.printStr("Kaiserstra");
                MyData[0] = 225;
                HW_API.printCmd(MyData[0]);
                HW_API.printStr("e");
                HW_API.feedLine(1);
                HW_API.ext_asc(false);
                HW_API.printStr("Tele:");
                HW_API.feedLine(1);

                HW_API.printStr("VAT:  6417373R");
                HW_API.feedLine(2);

                HW_API.textLmargin(18);

                HW_API.printStr(" 100003 Claire 0");
                HW_API.feedLine(1);

                HW_API.printStr("----------------------------------------");
                HW_API.feedLine(1);

                HW_API.printStr("Chk 806             13Oct'16 15:48");
                HW_API.feedLine(1);

                HW_API.printStr("----------------------------------------");
                HW_API.feedLine(1);

                HW_API.textLmargin(50);

                HW_API.textSize(1, 0);

                HW_API.printStr("To Go");
                HW_API.feedLine(1);

                HW_API.textSize(0, 0);

                HW_API.printStr("Gr Carml Macchiato                4.65");
                HW_API.feedLine(1);

                HW_API.printStr("  Decaf");
                HW_API.feedLine(1);

                HW_API.printStr("Gr Latte                          3.95");
                HW_API.feedLine(1);

                HW_API.printStr("  Hazelnut                        0.05");
                HW_API.feedLine(1);

                HW_API.printStr("Tl Chai Tea Latte                 3.45");
                HW_API.feedLine(1);

                HW_API.printStr("Visa                             13.77");
                HW_API.feedLine(1);

                HW_API.printStr("XXXXXXXXXXXX4258");
                HW_API.feedLine(2);

                HW_API.printStr("Subtotal                    EURO 12.55");
                HW_API.feedLine(1);

                HW_API.printStr("Tax 9.75%                   EURO  1.22");
                HW_API.feedLine(1);

                HW_API.printStr("Total                       EURO 13.77");
                HW_API.feedLine(1);

                HW_API.printStr("Change Due                  EURO  0.00");
                HW_API.feedLine(2);

                HW_API.printStr("========================================");
                HW_API.feedLine(1);

                HW_API.printStr("Thank you. Please visit us again");
                HW_API.feedLine(1);

                HW_API.printStr("For more information visit");
                HW_API.feedLine(1);

                HW_API.printStr("www.starbucks.de");
                HW_API.feedLine(6);

                //Full Cut
                HW_API.cut(hw_api.CUT_FULL);

                //Text Align left
                HW_API.textAlign(hw_api.ALIGN_LEFT);
            }            
        }

        private void button10_Click(object sender, EventArgs e)
        {
            openFileDialog1.InitialDirectory = Application.StartupPath;
            openFileDialog1.Filter = "BMP File (*.bmp) | *.bmp";
            openFileDialog1.FileName = "sample_1bit_image";
            openFileDialog1.ShowDialog();
            if (port_open(comboBox2.SelectedItem.ToString(), comboBox3.SelectedIndex) == 1)
            {
                HW_API.printImage(12, openFileDialog1.FileName);
            }           
        }
    }
}
