﻿using System.Runtime.InteropServices;

namespace Hwasung_Windows_SDK
{
  class HW_API
  {
        [DllImport("HW_API.dll")]
        public static extern int printerClose ();
        [DllImport("HW_API.dll")]
        public static extern int printerStatus ();
        [DllImport("HW_API.dll")]
        public static extern int printStr (string str);
        [DllImport("HW_API.dll")]
        public static extern int printCmd (int cmd );
        [DllImport("HW_API.dll")]
        public static extern int printerOpen(int interface_type, int port, string model, int flowcontrol, int baudrate);
        [DllImport("HW_API.dll")]
        public static extern int cut (int mode);
        [DllImport("HW_API.dll")]
        public static extern int feedLine (int line);
        [DllImport("HW_API.dll")]
        public static extern int ff();
        [DllImport("HW_API.dll")]
        public static extern int ext_asc (bool mode);
        [DllImport("HW_API.dll")]
        public static extern int textBox (int box);
        [DllImport("HW_API.dll")]
        public static extern int textLmargin (int margin);
        [DllImport("HW_API.dll")]
        public static extern int under_ko (int underline);
        [DllImport("HW_API.dll")]
        public static extern int under_as (int underline);
        [DllImport("HW_API.dll")]
        public static extern int textLinespace (int unit);
        [DllImport("HW_API.dll")]
        public static extern int textBold (int bold);
        [DllImport("HW_API.dll")]
        public static extern int feedUnit (int unit);
        [DllImport("HW_API.dll")]
        public static extern int textFont(int sytle);
        [DllImport("HW_API.dll")]
        public static extern int inter_font(int region);
        [DllImport("HW_API.dll")]
        public static extern int textAlign(int align);
        [DllImport("HW_API.dll")]
        public static extern int codePage(int code);
        [DllImport("HW_API.dll")]
        public static extern int pulse(int drawer, int time);
        [DllImport("HW_API.dll")]
        public static extern int twobyte_mode(int twobyte);
        [DllImport("HW_API.dll")]
        public static extern int textStyle(int width, int height, int under, int bold);
        [DllImport("HW_API.dll")]
        public static extern int textSize(int width, int height);
        [DllImport("HW_API.dll")]
        public static extern int barCode(string data, int type, int hri, int font, int width, int height);
        [DllImport("HW_API.dll")]
        public static extern int qrCode(string data , int version);
        [DllImport("HW_API.dll")]
        public static extern int pdf417(string data , int column);
        [DllImport("HW_API.dll")]
        public static extern int dataMatrix(string data, int size);
        [DllImport("HW_API.dll")]
        public static extern int setPagemode();
        [DllImport("HW_API.dll")]
        public static extern int setPagemodeDirection(int direction);
        [DllImport("HW_API.dll")]
        public static extern int setPagemodePosition(int x, int y, int dx, int dy);
        [DllImport("HW_API.dll")]
        public static extern int setLinemode();
        [DllImport("HW_API.dll")]
        public static extern int setTicketposition(string x, string y);
        [DllImport("HW_API.dll")]
        public static extern int printPagemode();
        [DllImport("HW_API.dll")]
        public static extern int printImage(int linecnt, string filename);



        public int INT_USB = 0;
        public int INT_SERIAL = 1;
         
        public int XON_XOFF = 0;
        public int RTS_CTS = 1;
        public int DTR_DSR = 2;

        public int CUT_BM = 2;
        public int CUT_FULL = 0;
        public int CUT_PARTIAL = 1;
        public int vb_Default = 400;
        public int ROW_DEFAULT = 300;

        //align
        public int ALIGN_LEFT = 0;
        public int ALIGN_CENTER = 1;
        public int ALIGN_RIGHT = 2;
        //region code                    
        public int LANG_EN = 0;
        public int LANG_FR = 1;
        public int LANG_DE = 2;
        public int LANG_GB = 3;
        public int LANG_DM = 4;
        public int LANG_SW = 5;
        public int LANG_IT = 6;
        public int LANG_SP = 7;
        public int LANG_JA = 8;
        public int LANG_NO = 9;
        public int LANG_DM2 = 10;
        public int LANG_SP2 = 11;
        public int LANG_LA = 12;
        public int LANG_KO = 13;
                                         
        public int PAGEDIRECTION_0 = 0   ;
        public int PAGEDIRECTION_L_90 = 1;
        public int PAGEDIRECTION_180 = 2 ;
        public int PAGEDIRECTION_R_90 = 3;

        public int FONT_KR24_EN24 = 0;  //KR 24 Go, EN 12x24
        public int FONT_KR16_EN24 = 1;  //KR 16 Do, EN 12x24
        public int FONT_JP24_EN24 = 2;  //JP 24 My, EN 12x24
        public int FONT_CN24_EN24 = 3;  //CN 24 Go, EN 12x24
        public int FONT_KR24_EN16 = 4;  //KR 24 Go, EN 8x16
        public int FONT_KR16_EN16 = 5;  //KR 16 Do, EN 8x16
        public int FONT_JP24_EN16 = 6;  //JP 24 MY, EN 8x16
        public int FONT_CN24_EN16 = 7;  //CN 24 Go, EN 8x16

        public int CURRENT = 400;

        //codepage
        public int CODE_PC437 = 0;
        public int CODE_KANA = 1;
        public int CODE_PC850 = 2;
        public int CODE_PC860 = 3;
        public int CODE_PC863 = 4;
        public int CODE_PC865 = 5;
        public int CODE_1250 = 6;
        public int CODE_1251 = 7;
        public int CODE_1252 = 8;
        public int CODE_PC866 = 9;

        public int DRAWER_1 = 0;
        public int DRAWER_2 = 1;
        public int PULSE_100 = 0;
        public int PULSE_200 = 1;
        public int PULSE_300 = 2;
        public int PULSE_400 = 3;
        public int PULSE_500 = 4;

        public int BARCODE_UPC_A = 0;
        public int BARCODE_UPC_E = 1;
        public int BARCODE_EAN13 = 2;
        public int BARCODE_EAN8 = 3;
        public int BARCODE_CODE39 = 4;
        public int BARCODE_ITF = 5;
        public int BARCODE_CODABAR = 6;
        public int BARCODE_CODE93 = 7;
        public int BARCODE_CODE128A = 8;
        public int BARCODE_CODE128B = 9;
        public int BARCODE_CODE128C = 10;

        public int HRI_NONE = 0;
        public int HRI_ABOVE = 1;
        public int HRI_BELOW = 2;
        public int HRI_BOTH = 3;
        public int BARCODE_FONT_A = 0;
        public int BARCODE_FONT_B = 1;


        public int QR_VER_1 = 1;
        public int QR_VER_3 = 3;
        public int QR_VER_5 = 5;
        public int QR_VER_9 = 9;
        public int DM_20x20 = 20;
        public int DM_24x24 = 24;
        public int DM_36x36 = 36;
        public int DM_44x44 = 44;

        public int LINESPC_DEFAULT = 32;
  }
}
